/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "github.com/minio/minio-operator/pkg/apis/miniocontroller/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMinioInstances implements MinioInstanceInterface
type FakeMinioInstances struct {
	Fake *FakeMinioV1beta1
	ns   string
}

var minioinstancesResource = schema.GroupVersionResource{Group: "minio.io.io", Version: "v1beta1", Resource: "minioinstances"}

var minioinstancesKind = schema.GroupVersionKind{Group: "minio.io.io", Version: "v1beta1", Kind: "MinioInstance"}

// Get takes name of the minioInstance, and returns the corresponding minioInstance object, and an error if there is any.
func (c *FakeMinioInstances) Get(name string, options v1.GetOptions) (result *v1beta1.MinioInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(minioinstancesResource, c.ns, name), &v1beta1.MinioInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MinioInstance), err
}

// List takes label and field selectors, and returns the list of MinioInstances that match those selectors.
func (c *FakeMinioInstances) List(opts v1.ListOptions) (result *v1beta1.MinioInstanceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(minioinstancesResource, minioinstancesKind, c.ns, opts), &v1beta1.MinioInstanceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.MinioInstanceList{ListMeta: obj.(*v1beta1.MinioInstanceList).ListMeta}
	for _, item := range obj.(*v1beta1.MinioInstanceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested minioInstances.
func (c *FakeMinioInstances) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(minioinstancesResource, c.ns, opts))

}

// Create takes the representation of a minioInstance and creates it.  Returns the server's representation of the minioInstance, and an error, if there is any.
func (c *FakeMinioInstances) Create(minioInstance *v1beta1.MinioInstance) (result *v1beta1.MinioInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(minioinstancesResource, c.ns, minioInstance), &v1beta1.MinioInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MinioInstance), err
}

// Update takes the representation of a minioInstance and updates it. Returns the server's representation of the minioInstance, and an error, if there is any.
func (c *FakeMinioInstances) Update(minioInstance *v1beta1.MinioInstance) (result *v1beta1.MinioInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(minioinstancesResource, c.ns, minioInstance), &v1beta1.MinioInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MinioInstance), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMinioInstances) UpdateStatus(minioInstance *v1beta1.MinioInstance) (*v1beta1.MinioInstance, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(minioinstancesResource, "status", c.ns, minioInstance), &v1beta1.MinioInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MinioInstance), err
}

// Delete takes name of the minioInstance and deletes it. Returns an error if one occurs.
func (c *FakeMinioInstances) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(minioinstancesResource, c.ns, name), &v1beta1.MinioInstance{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMinioInstances) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(minioinstancesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.MinioInstanceList{})
	return err
}

// Patch applies the patch and returns the patched minioInstance.
func (c *FakeMinioInstances) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.MinioInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(minioinstancesResource, c.ns, name, data, subresources...), &v1beta1.MinioInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MinioInstance), err
}
